--
-- TrueMirror
--
-- Seiten Spiegel (Links/Rechts)
--
-- by Mogli
--

TrueMirror = {};

local TrueMirror_directory = g_currentModDirectory;

function TrueMirror.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function TrueMirror:load()
	self.showTrueMirror = false;
	self.trueMirrorLinked = false;
	self.lastTrueMirrorLinked = false;
	self.trueMirrorRootNode = getChild(loadI3DFile(Utils.getFilename("TrueMirror.i3d", TrueMirror_directory)),"true_mirror");
	self.trueMirrorTimeout = 0;
	self.trueLeftMirror = getChild(self.trueMirrorRootNode,"left");
	self.trueRightMirror = getChild(self.trueMirrorRootNode,"right");
	self.trueMirrorTx, self.trueMirrorTy, self.trueMirrorTz = getTranslation(self.trueLeftMirror);
	self.trueMirrorRx, self.trueMirrorRy, self.trueMirrorRz = getRotation(self.trueLeftMirror);
	self.trueMirrorSx, self.trueMirrorSy, self.trueMirrorSz = getScale(self.trueLeftMirror);
	self.trueMirrorDx = 0;
	self.trueMirrorDy = 0;
	self.trueMirrorDz = 0;
	self.trueMirrorDu = 0;
	self.trueMirrorDv = 0;
	self.trueMirrorDs = 0;
end;

function TrueMirror:mouseEvent(posX, posY, isDown, isUp, button)
end;

function TrueMirror:keyEvent(unicode, sym, modifier, isDown)
end;

function TrueMirror:update()

	local moveMirror = false;

    if self:getIsActiveForInput() then
		if self.trueMirrorTimeout <= 0 and InputBinding.hasEvent(InputBinding.TrueMirror) then
    	    --self.trueMirrorTimeout = 100;
			self.showTrueMirror = not self.showTrueMirror;
	    end;
		if self.lastTrueMirrorLinked then
			if InputBinding.hasEvent(InputBinding.TrueMirror_fwd) then
				moveMirror = true;
				self.trueMirrorDz = self.trueMirrorDz+0.05;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_back) then
				moveMirror = true;
				self.trueMirrorDz = self.trueMirrorDz-0.05;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_mup) then
				moveMirror = true;
				self.trueMirrorDv = self.trueMirrorDv+0.05;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_mdown) then
				moveMirror = true;
				self.trueMirrorDv = self.trueMirrorDv-0.05;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_in) then
				moveMirror = true;
				self.trueMirrorDx = self.trueMirrorDx+0.05;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_out) then
				moveMirror = true;
				self.trueMirrorDx = self.trueMirrorDx-0.05;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_right) then
				moveMirror = true;
				self.trueMirrorDy = self.trueMirrorDy+0.02;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_left) then
				moveMirror = true;
				self.trueMirrorDy = self.trueMirrorDy-0.02;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_rup) then
				moveMirror = true;
				self.trueMirrorDu = self.trueMirrorDu+0.02;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_rdown) then
				moveMirror = true;
				self.trueMirrorDu = self.trueMirrorDu-0.02;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_big) then
				moveMirror = true;
				self.trueMirrorDs = self.trueMirrorDs+0.1;
			end;
			if InputBinding.hasEvent(InputBinding.TrueMirror_small) then
				moveMirror = true;
				self.trueMirrorDs = self.trueMirrorDs-0.1;
			end;
		end;
	end;
	
	if self.trueMirrorTimeout > 0 then self.trueMirrorTimeout = self.trueMirrorTimeout - 1; end;
	
	self.trueMirrorLinked = self.showTrueMirror and ( self.characterNode ~= nil );
	
	if self.lastTrueMirrorLinked ~= self.trueMirrorLinked then		
		if self.trueMirrorLinked then
			--link(self.characterNode,self.trueMirrorRootNode);
			--local x, y, z = getWorldRotation(self.trueMirrorRootNode);
			--setRotation(self.trueMirrorRootNode,-x,-y,-z);
			link(getParent(self.characterNode),self.trueMirrorRootNode);
			local x, y, z = getTranslation(self.characterNode);
			setTranslation(self.trueMirrorRootNode,x,y,z);
			self.lastTrueMirrorLinked = true;
		elseif self.trueMirrorRootNode ~= 0 then
			unlink(self.trueMirrorRootNode);
			self.lastTrueMirrorLinked = false;
		end;
	elseif moveMirror then
		setTranslation(self.trueLeftMirror,self.trueMirrorTx+self.trueMirrorDx,self.trueMirrorTy+self.trueMirrorDv,self.trueMirrorTz+self.trueMirrorDz);
		setTranslation(self.trueRightMirror,-self.trueMirrorTx-self.trueMirrorDx,self.trueMirrorTy+self.trueMirrorDv,self.trueMirrorTz+self.trueMirrorDz);
		setRotation(self.trueLeftMirror,self.trueMirrorRx+self.trueMirrorDu,self.trueMirrorRy+self.trueMirrorDy,self.trueMirrorRz);
		setRotation(self.trueRightMirror,self.trueMirrorRx+self.trueMirrorDu,-self.trueMirrorRy-self.trueMirrorDy,self.trueMirrorRz);		
		setScale(self.trueLeftMirror,self.trueMirrorSx+self.trueMirrorDs,self.trueMirrorSy+self.trueMirrorDs,self.trueMirrorSz+self.trueMirrorDs);		
		setScale(self.trueRightMirror,self.trueMirrorSx+self.trueMirrorDs,self.trueMirrorSy+self.trueMirrorDs,self.trueMirrorSz+self.trueMirrorDs);		
	end;
end;
	
function TrueMirror:draw()
    if not self.showTrueMirror then
        g_currentMission:addHelpButtonText(string.format(Steerable.TrueMirror_on, self.typeDesc), InputBinding.TrueMirror);
    else
        g_currentMission:addHelpButtonText(string.format(Steerable.TrueMirror_off, self.typeDesc), InputBinding.TrueMirror);
    end;
	
end;

function TrueMirror:delete()
end;

function TrueMirror:onLeave()
end;

function TrueMirror:getSaveAttributesAndNodes(nodeIdent)
	local attributes = "";
	if self.trueMirrorLinked then
		attributes = 'trueMirror="1" '
		attributes = attributes..'trueMirrorDx="'..self.trueMirrorDx..'" '		
		attributes = attributes..'trueMirrorDy="'..self.trueMirrorDy..'" '
		attributes = attributes..'trueMirrorDz="'..self.trueMirrorDz..'" '
		attributes = attributes..'trueMirrorDu="'..self.trueMirrorDu..'" '
		attributes = attributes..'trueMirrorDv="'..self.trueMirrorDv..'" '
		attributes = attributes..'trueMirrorDs="'..self.trueMirrorDs..'" '
	end
	return attributes
end;


function TrueMirror:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	if not resetVehicles or resetVehicles == nil then
		local l = getXMLInt(xmlFile, key.."#trueMirror");
		if l == 1 then
			self.trueMirrorLinked = true;			
			local x = getXMLFloat(xmlFile, key.."#trueMirrorDx"); self.trueMirrorDx = Utils.getNoNil(x,0);
			local y = getXMLFloat(xmlFile, key.."#trueMirrorDy"); self.trueMirrorDy = Utils.getNoNil(y,0);
			local z = getXMLFloat(xmlFile, key.."#trueMirrorDz"); self.trueMirrorDz = Utils.getNoNil(z,0);
			local u = getXMLFloat(xmlFile, key.."#trueMirrorDu"); self.trueMirrorDu = Utils.getNoNil(u,0);
			local v = getXMLFloat(xmlFile, key.."#trueMirrorDv"); self.trueMirrorDv = Utils.getNoNil(v,0);
			local s = getXMLFloat(xmlFile, key.."#trueMirrorDs"); self.trueMirrorDs = Utils.getNoNil(s,0);
		end;	
	end;
	return BaseMission.VEHICLE_LOAD_OK;
end

